#pragma once

#include "gui.h"
#include "framebuffer.h"
#include "ppc.h"
#include "tm.h"
#include "CGInterface.h"

class Scene {
public:

	GUI *gui;
	FrameBuffer *fb, *fb3, *hwfb;
	PPC *ppc, *ppc3;
	TM *tms;
	int tmsN;
	V3 hwClearColor;
	Scene();
	void Render(PPC *renderPPC, FrameBuffer *renderFB);
	void Render();
	void RenderHW();
	void DBG();
	void NewButton();
	FrameBuffer *textures;
	int texturesN;
	int needInitHW;
	CGInterface *cgi;
	ShaderOneInterface *soi;
	float bwFraction;
	void RayTrace(PPC *ppc, FrameBuffer *fb);
	int RayTrace(V3 rayD, V3 rayO, V3 &colv, V3 &rrD, V3 &rrO);
	int IntersectTriangleWithRay(V3 v0, V3 v1, V3 v2, V3 rayO, V3 rayDir, V3 &abc, float &currt);
};

extern Scene *scene;